//+------------------------------------------------------------------+ 
// #4X Gann HiLo Float        \/
// Knowledge of the ancients ( )
//______________________o0o___(_)___o0o_____
//___Xard777_____________________2009_
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern bool show.line.data=true;

//   Var    //////////////////////////////////////////////////////////////
extern int float=200,use_fibos=1,Backtesting=0;
string short_name;

double f,c1,high_bar,Low_bar,bars_high,bars_low,DecNos;
double cumulativeV,FLOATV,cumulativeV2,loopbegin2,swing;
double swingv,loopbegin1,cnt,prevbars;
double newcv,CV,CV2;
double fib125,fib25,fib375,fib50,fib625,fib75,fib875;
double CVL,CVL1,CVL2,CVL3,CVL4;
double Buffer1[];
double Buffer2[];

bool   first = true , first1 = true;

int shift,swing_time;
int cvstart,cvend,bar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   
   ObjectDelete("swingtop");
   ObjectDelete("swingbottom"); 
 
   ObjectDelete( "fib125" );
   ObjectDelete( "fib25" );
   ObjectDelete( "fib375" );
   ObjectDelete( "fib50" );
   ObjectDelete( "fib625" );
   ObjectDelete( "fib75" );
   ObjectDelete( "fib875" );

   ObjectDelete( "fib125t" );
   ObjectDelete( "fib25t" );
   ObjectDelete( "fib375t" );
   ObjectDelete( "fib50t" );
   ObjectDelete( "fib625t" );
   ObjectDelete( "fib75t" );
   ObjectDelete( "fib875t" );

   ObjectDelete("CVSTART");
   ObjectDelete("CVEND");
   ObjectDelete("swingend");
   ObjectDelete("swingend2");
   ObjectDelete("swingend3");
   ObjectDelete("swingend4");
   ObjectDelete("swingend5");
   ObjectDelete("swingend6");
   ObjectDelete("swingend7");
   ObjectDelete("swingend8");
   ObjectDelete("swingend9");
      
   short_name="Float";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   SetIndexStyle(0,DRAW_NONE );
   SetIndexBuffer(0,Buffer1);
   SetIndexDrawBegin(0,Buffer1);
   
   SetIndexStyle(1,DRAW_NONE );
   SetIndexBuffer(1,Buffer2);
   SetIndexDrawBegin(1,Buffer2);

   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
 {
 
ObjectDelete("swingtop");
ObjectDelete("swingbottom"); 
 
ObjectDelete( "fib125" );
ObjectDelete( "fib25" );
ObjectDelete( "fib375" );
ObjectDelete( "fib50" );
ObjectDelete( "fib625" );
ObjectDelete( "fib75" );
ObjectDelete( "fib875" );

ObjectDelete( "fib125t" );
ObjectDelete( "fib25t" );
ObjectDelete( "fib375t" );
ObjectDelete( "fib50t" );
ObjectDelete( "fib625t" );
ObjectDelete( "fib75t" );
ObjectDelete( "fib875t" );

ObjectDelete("CVSTART");
ObjectDelete("CVEND");
ObjectDelete("swingend");
ObjectDelete("swingend2");
ObjectDelete("swingend3");
ObjectDelete("swingend4");
ObjectDelete("swingend5");
ObjectDelete("swingend6");
ObjectDelete("swingend7");
ObjectDelete("swingend8");
ObjectDelete("swingend9");

Comment("");
  return(0);
 }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   
   if (StringFind (Symbol(), "JPY", 0) != -1){ DecNos = 2;}
   else { DecNos = 4; } 
   
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); // Exit if na data
    
   cumulativeV=0;
   cumulativeV2=0;
   int SetLoopCount=0;
      
   if( Bars < prevbars || Bars-prevbars>1 ) //If 1
   {
    first = True;
    first1 = True;
    prevbars = Bars;
    FLOATV=0;

   if( first )                               //if 2
   {
	loopbegin1 = Bars-float-1;
	loopbegin2 = Bars-float-1;
	first = False;

   loopbegin1 = loopbegin1+1;

for( shift=loopbegin1;shift>=0;shift--)  //  for 1
{

//find high and low
high_bar = High[Highest(NULL,0,MODE_HIGH,float,1)]; 
Low_bar  =  Low[Lowest(NULL,0,MODE_LOW,float,1)]; 

//find bar counts
bars_high = Highest(NULL,0,MODE_HIGH,float,1);
bars_low  = Lowest(NULL,0,MODE_LOW,float,1);

//find swing price differance
swing = High[Highest(NULL,0,MODE_HIGH,float,1)] - Low[Lowest(NULL,0,MODE_LOW,float,1)];

//find float time barcount
swing_time = MathAbs(bars_low-bars_high);

//find cumulative volume for float period
if( bars_high < bars_low )
{
cvstart=bars_low;
cvend=bars_high;
}
else
{
cvstart=bars_high;
cvend=bars_low;
}

if( first1 && FLOATV == 0 )                       //   if   3
{

for( shift=cvstart;shift>=cvend;shift--)
{
FLOATV=FLOATV+Volume[shift];
first1 = False;}
}

}

//find cumulative volume since last turnover
for( shift=cvstart;shift>=0;shift--)         //  for    2
{
cumulativeV=cumulativeV+Volume[shift];

if( cumulativeV >= FLOATV )
{
cumulativeV=0;
}

Buffer1[shift] = cumulativeV*0.001; //Blue
Buffer2[shift] = FLOATV*0.001;      //Red
/*
Comment(
"\n",
"\n","high was   ",bars_high,"  bars ago",
"\n","Low was    ",bars_low," bars ago","\n",
"\n","Float time was  =      ", swing_time," bars",
"\n","Float Vol. left    =     ",FLOATV-cumulativeV,
"\n","Float Volume    =     ",FLOATV
);
*/
 ObjectDelete("swingtop");
 ObjectCreate("swingtop", OBJ_TREND  , 0, Time[cvstart],high_bar,Time[1],high_bar);
 ObjectSet("swingtop" , OBJPROP_STYLE, STYLE_SOLID);
 ObjectSet("swingtop" , OBJPROP_COLOR , Blue );
 ObjectSet("swingtop" , OBJPROP_RAY , 0  );
 ObjectSet("swingtop" , OBJPROP_WIDTH , 1 );

 ObjectDelete("swingbottom");
 ObjectCreate("swingbottom", OBJ_TREND , 0, Time[cvstart],Low_bar,Time[1],Low_bar);
 ObjectSet("swingbottom" , OBJPROP_STYLE, STYLE_SOLID);
 ObjectSet("swingbottom" , OBJPROP_COLOR , Blue );
 ObjectSet("swingbottom" , OBJPROP_RAY , 0  );
 ObjectSet("swingbottom"  , OBJPROP_WIDTH , 1 );
 
 //fibos
if( use_fibos == 1 ) 
{
ObjectDelete( "fib125" );
ObjectDelete( "fib25" );
ObjectDelete( "fib375" );
ObjectDelete( "fib50" );
ObjectDelete( "fib625" );
ObjectDelete( "fib75" );
ObjectDelete( "fib875" );

fib125=((high_bar-Low_bar)*0.125)+Low_bar;
fib25=((high_bar-Low_bar)*0.25)+Low_bar;
fib375=((high_bar-Low_bar)*0.375)+Low_bar;
fib50=((high_bar-Low_bar)/2)+Low_bar;
fib625=((high_bar-Low_bar)*0.625)+Low_bar;
fib75=((high_bar-Low_bar)*0.75)+Low_bar;
fib875=((high_bar-Low_bar)*0.875)+Low_bar;

 
 
 if (show.line.data) {  
      ////////////////////////////
      ObjectDelete("ftx");
      ObjectCreate("ftx", OBJ_LABEL, 1, 0, 0);
      ObjectSetText("ftx", "1/8th: "+DoubleToStr(fib25-fib125,DecNos), 16, "Arial", DodgerBlue);
      ObjectSet("ftx", OBJPROP_CORNER, 0);
      ObjectSet("ftx", OBJPROP_BACK, false);
      ObjectSet("ftx", OBJPROP_XDISTANCE, 485);
      ObjectSet("ftx", OBJPROP_YDISTANCE, 5);
      /////////////////////////////////////////
}

 ObjectCreate("fib125", OBJ_TREND  , 0, Time[cvstart],fib125,Time[1],fib125 );
 ObjectSet("fib125" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib125" , OBJPROP_COLOR , Yellow );
 ObjectSet("fib125" , OBJPROP_BACK, 1 );
 ObjectSet("fib125" , OBJPROP_RAY , 0  );
 ObjectSet("fib125" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib125t", OBJ_TEXT  , 0, Time[1],fib125  );
 ObjectSetText("fib125t" , "12.5%", 10 , "Arial", DimGray);

 ObjectCreate("fib25", OBJ_TREND  , 0, Time[cvstart],fib25,Time[1],fib25 );
 ObjectSet("fib25" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib25" , OBJPROP_COLOR , HotPink );
 ObjectSet("fib25" , OBJPROP_BACK, 1 );
 ObjectSet("fib25" , OBJPROP_RAY , 0  );
 ObjectSet("fib25" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib25t", OBJ_TEXT  , 0, Time[1],fib25  );
 ObjectSetText("fib25t" , "25%", 10 , "Arial", DimGray);
 
 ObjectCreate("fib375", OBJ_TREND  , 0, Time[cvstart],fib375,Time[1],fib375 );
 ObjectSet("fib375" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib375" , OBJPROP_COLOR , Lime );
 ObjectSet("fib375" , OBJPROP_BACK, 1 );
 ObjectSet("fib375" , OBJPROP_RAY , 0  );
 ObjectSet("fib375" , OBJPROP_WIDTH , 1 );
  ObjectCreate("fib375t", OBJ_TEXT  , 0, Time[1],fib375   );
 ObjectSetText("fib375t" , "37.5%", 10 , "Arial", DimGray);
 
 ObjectCreate("fib50", OBJ_TREND  , 0, Time[cvstart],fib50,Time[1],fib50 );
 ObjectSet("fib50" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib50" , OBJPROP_COLOR , White );
 ObjectSet("fib50" , OBJPROP_BACK, 1 );
 ObjectSet("fib50" , OBJPROP_RAY , 0  );
 ObjectSet("fib50" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib50t", OBJ_TEXT  , 0, Time[1],fib50  );
 ObjectSetText("fib50t" , "50%", 10 , "Arial", DimGray);

 ObjectCreate("fib625", OBJ_TREND  , 0, Time[cvstart],fib625,Time[1],fib625 );
 ObjectSet("fib625" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib625" , OBJPROP_COLOR , Lime );
 ObjectSet("fib625" , OBJPROP_BACK, 1 );
 ObjectSet("fib625" , OBJPROP_RAY , 0  );
 ObjectSet("fib625" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib625t", OBJ_TEXT  , 0, Time[1],fib625  );
 ObjectSetText("fib625t" , "62.5%", 10 , "Arial", DimGray);
 
 ObjectCreate("fib75", OBJ_TREND  , 0, Time[cvstart],fib75,Time[1],fib75 );
 ObjectSet("fib75" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib75" , OBJPROP_COLOR , HotPink );
 ObjectSet("fib75" , OBJPROP_BACK, 1 );
 ObjectSet("fib75" , OBJPROP_RAY , 0  );
 ObjectSet("fib75" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib75t", OBJ_TEXT  , 0, Time[1],fib75  );
 ObjectSetText("fib75t" , "75%", 10 , "Arial", DimGray); 

 ObjectCreate("fib875", OBJ_TREND  , 0, Time[cvstart],fib875,Time[1],fib875 );
 ObjectSet("fib875" , OBJPROP_STYLE, STYLE_SOLID );
 ObjectSet("fib875" , OBJPROP_COLOR , Yellow );
 ObjectSet("fib875" , OBJPROP_BACK, 1 );
 ObjectSet("fib875" , OBJPROP_RAY , 0  );
 ObjectSet("fib875" , OBJPROP_WIDTH , 1 );
 ObjectCreate("fib875t", OBJ_TEXT  , 0, Time[1],fib875  );
 ObjectSetText("fib875t" , "87.5%", 10 , "Arial", DimGray);

}
else
{

ObjectDelete( "fib125" );
ObjectDelete( "fib25" );
ObjectDelete( "fib375" );
ObjectDelete( "fib50" );
ObjectDelete( "fib625" );
ObjectDelete( "fib75" );
ObjectDelete( "fib875" );

}

//vert. float lines. these draw the lines that calculate the float
//if you change "trendline" to "Vline" it will draw through oscillators too.might be fun
 ObjectDelete("CVSTART");
 ObjectCreate("CVSTART", OBJ_TREND  , 0, Time[cvstart],high_bar,Time[cvstart],Low_bar*Point);
 ObjectSet("CVSTART" , OBJPROP_STYLE, STYLE_SOLID);
 ObjectSet("CVSTART" , OBJPROP_COLOR , Lime );
 ObjectSet("CVSTART" , OBJPROP_RAY , 0  );
 ObjectSet("CVSTART" , OBJPROP_WIDTH , 1 );

 ObjectDelete("CVEND");
 ObjectCreate("CVEND", OBJ_TREND , 0, Time[cvend],high_bar,Time[cvend],Low_bar*Point);
 ObjectSet("CVEND" , OBJPROP_STYLE, STYLE_SOLID);
 ObjectSet("CVEND" , OBJPROP_COLOR , Red );
 ObjectSet("CVEND" , OBJPROP_RAY , 0  );
 ObjectSet("CVEND" , OBJPROP_WIDTH , 1 );

//vert float predictions. These are only time based.
//see blue histogram for real float values.
//if you change "trendline" to "Vline" it will draw through oscillators too.might be fun
if ( cvend-swing_time > 0 )
{
 ObjectDelete("swingend");
 ObjectCreate("swingend", OBJ_TREND , 0, Time[(cvend-swing_time)+5],high_bar,Time[cvend-swing_time+5],Low_bar);
 ObjectSet("swingend" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend" , OBJPROP_COLOR , Red );
 ObjectSet("swingend" , OBJPROP_BACK , 1 );
 ObjectSet("swingend" , OBJPROP_RAY , 0  );
 ObjectSet("swingend" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend");

if( cvend-(swing_time*2)>0 )
{
 ObjectDelete("swingend2");
 ObjectCreate("swingend2", OBJ_TREND , 0, Time[(cvend-(swing_time*2))+5],high_bar,Time[cvend-(swing_time*2)+5],Low_bar);
 ObjectSet("swingend2" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend2" , OBJPROP_COLOR , Red );
 ObjectSet("swingend2" , OBJPROP_BACK , 1 );
 ObjectSet("swingend2", OBJPROP_RAY , 0  );
 ObjectSet("swingend2" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend2");

if( cvend-(swing_time*3)>0 )
{
 ObjectDelete("swingend3");
 ObjectCreate("swingend3", OBJ_TREND , 0, Time[(cvend-(swing_time*3))+5],high_bar,Time[cvend-(swing_time*3)+5],Low_bar);
 ObjectSet("swingend3" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend3" , OBJPROP_COLOR , Red );
 ObjectSet("swingend3" , OBJPROP_BACK , 1 );
 ObjectSet("swingend3", OBJPROP_RAY , 0  );
 ObjectSet("swingend3" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend3");

if( cvend-(swing_time*4)>0 )
{
 ObjectDelete("swingend4");
 ObjectCreate("swingend4", OBJ_TREND , 0, Time[(cvend-(swing_time*4))+5],high_bar,Time[cvend-(swing_time*4)+5],Low_bar);
 ObjectSet("swingend4" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend4" , OBJPROP_COLOR , Red );
 ObjectSet("swingend4" , OBJPROP_BACK , 1 );
 ObjectSet("swingend4", OBJPROP_RAY , 0  );
 ObjectSet("swingend4" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend4");

if( cvend-(swing_time*5)>0 )
{
 ObjectDelete("swingend5");
 ObjectCreate("swingend5", OBJ_TREND , 0, Time[(cvend-(swing_time*5))+5],high_bar,Time[cvend-(swing_time*5)+5],Low_bar);
 ObjectSet("swingend5" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend5" , OBJPROP_COLOR , Red );
 ObjectSet("swingend5" , OBJPROP_BACK , 1 );
 ObjectSet("swingend5", OBJPROP_RAY , 0  );
 ObjectSet("swingend5" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend5");

if( cvend-(swing_time*6)>0 )
{
 ObjectDelete("swingend6");
 ObjectCreate("swingend6", OBJ_TREND , 0, Time[cvend-(swing_time*6)+5],high_bar,Time[cvend-(swing_time*6)+5],Low_bar);
 ObjectSet("swingend6" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend6" , OBJPROP_COLOR , Red );
 ObjectSet("swingend6" , OBJPROP_BACK , 1 );
 ObjectSet("swingend6", OBJPROP_RAY , 0  );
 ObjectSet("swingend6" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend6");

if( cvend-(swing_time*7)>0 )
{
 ObjectDelete("swingend7");
 ObjectCreate("swingend7", OBJ_TREND , 0, Time[cvend-(swing_time*7)+5],high_bar,Time[cvend-(swing_time*7)+5],Low_bar);
 ObjectSet("swingend7" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend7" , OBJPROP_COLOR , Red );
 ObjectSet("swingend7" , OBJPROP_BACK , 1 );
 ObjectSet("swingend7", OBJPROP_RAY , 0  );
 ObjectSet("swingend7" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend7");

if( cvend-(swing_time*8)>0 )
{
 ObjectDelete("swingend8");
 ObjectCreate("swingend8", OBJ_TREND , 0, Time[cvend-(swing_time*8)+5],high_bar,Time[cvend-(swing_time*8)+5],Low_bar);
 ObjectSet("swingend8" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend8" , OBJPROP_COLOR , Red );
 ObjectSet("swingend8" , OBJPROP_BACK , 1 );
 ObjectSet("swingend8", OBJPROP_RAY , 0  );
 ObjectSet("swingend8" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend8");

if( cvend-(swing_time*9)>0 )
{
 ObjectDelete("swingend9");
 ObjectCreate("swingend9", OBJ_TREND , 0, Time[cvend-(swing_time*9)+5],high_bar,Time[cvend-(swing_time*9)+5],Low_bar);
 ObjectSet("swingend9" , OBJPROP_STYLE, STYLE_DOT);
 ObjectSet("swingend9" , OBJPROP_COLOR , Red );
 ObjectSet("swingend9" , OBJPROP_BACK , 1 );
 ObjectSet("swingend9", OBJPROP_RAY , 0  );
 ObjectSet("swingend9" , OBJPROP_WIDTH , 1 );
}
else ObjectDelete("swingend9");

//comment out anything you"re not using it will help with speed.
if( Backtesting == 1 )
{
GlobalVariableSet("fib125",fib125);
GlobalVariableSet("fib25",fib25);
GlobalVariableSet("fib375",fib375);
GlobalVariableSet("fib50",fib50);
GlobalVariableSet("fib625",fib625);
GlobalVariableSet("fib75",fib75);
GlobalVariableSet("fib875",fib875);

GlobalVariableSet("swingtop",high_bar);
GlobalVariableSet("swingbottom",Low_bar);
GlobalVariableSet("CVSTART",cvstart);
GlobalVariableSet("CVEND",cvend);
GlobalVariableSet("FLOATV",FLOATV);
GlobalVariableSet("cumulativeV",cumulativeV);
GlobalVariableSet("swing_time",swing_time);
GlobalVariableSet("bars_high",bars_high);
GlobalVariableSet("bars_low",bars_low);

if( cvend-swing_time>0 )
GlobalVariableSet("swingend",(cvend-swing_time)+5);

if( cvend-(swing_time*2)>0 )
GlobalVariableSet("swingend2",cvend-(swing_time*2)+5);

if( cvend-(swing_time*3)>0 )
GlobalVariableSet("swingend3",cvend-(swing_time*3)+5);

if( cvend-(swing_time*4)>0 )
GlobalVariableSet("swingend4",cvend-(swing_time*4)+5);

if( cvend-(swing_time*5)>0 )
GlobalVariableSet("swingend5",cvend-(swing_time*5)+5);

if( cvend-(swing_time*6)>0 )
GlobalVariableSet("swingend6",cvend-(swing_time*6)+5);

if( cvend-(swing_time*7)>0 )
GlobalVariableSet("swingend7",cvend-(swing_time*7)+5);

if( cvend-(swing_time*8)>0 )
GlobalVariableSet("swingend8",cvend-(swing_time*8)+5);

if( cvend-(swing_time*9)>0 )
GlobalVariableSet("swingend9",cvend-(swing_time*9)+5);
 
}  //   end  Backtesting
     
    
   }
  }
 }
 return(0);
}
  

